/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-ml-classifiers-0.3.0-1quantal-20150330-2020/msg/ClassDataPoint.msg
 *
 */


#ifndef ML_CLASSIFIERS_MESSAGE_CLASSDATAPOINT_H
#define ML_CLASSIFIERS_MESSAGE_CLASSDATAPOINT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace ml_classifiers
{
template <class ContainerAllocator>
struct ClassDataPoint_
{
  typedef ClassDataPoint_<ContainerAllocator> Type;

  ClassDataPoint_()
    : target_class()
    , point()  {
    }
  ClassDataPoint_(const ContainerAllocator& _alloc)
    : target_class(_alloc)
    , point(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _target_class_type;
  _target_class_type target_class;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _point_type;
  _point_type point;




  typedef boost::shared_ptr< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ClassDataPoint_

typedef ::ml_classifiers::ClassDataPoint_<std::allocator<void> > ClassDataPoint;

typedef boost::shared_ptr< ::ml_classifiers::ClassDataPoint > ClassDataPointPtr;
typedef boost::shared_ptr< ::ml_classifiers::ClassDataPoint const> ClassDataPointConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ml_classifiers::ClassDataPoint_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ml_classifiers

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'ml_classifiers': ['/tmp/buildd/ros-hydro-ml-classifiers-0.3.0-1quantal-20150330-2020/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
{
  static const char* value()
  {
    return "46bea2d2ef979a71ef0bfa470e5978ff";
  }

  static const char* value(const ::ml_classifiers::ClassDataPoint_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x46bea2d2ef979a71ULL;
  static const uint64_t static_value2 = 0xef0bfa470e5978ffULL;
};

template<class ContainerAllocator>
struct DataType< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ml_classifiers/ClassDataPoint";
  }

  static const char* value(const ::ml_classifiers::ClassDataPoint_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string target_class\n\
float64[] point\n\
";
  }

  static const char* value(const ::ml_classifiers::ClassDataPoint_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.target_class);
      stream.next(m.point);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ClassDataPoint_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ml_classifiers::ClassDataPoint_<ContainerAllocator>& v)
  {
    s << indent << "target_class: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.target_class);
    s << indent << "point[]" << std::endl;
    for (size_t i = 0; i < v.point.size(); ++i)
    {
      s << indent << "  point[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.point[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ML_CLASSIFIERS_MESSAGE_CLASSDATAPOINT_H
