/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-ml-classifiers-0.3.0-1quantal-20150330-2020/srv/ClassifyData.srv
 *
 */


#ifndef ML_CLASSIFIERS_MESSAGE_CLASSIFYDATAREQUEST_H
#define ML_CLASSIFIERS_MESSAGE_CLASSIFYDATAREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <ml_classifiers/ClassDataPoint.h>

namespace ml_classifiers
{
template <class ContainerAllocator>
struct ClassifyDataRequest_
{
  typedef ClassifyDataRequest_<ContainerAllocator> Type;

  ClassifyDataRequest_()
    : identifier()
    , data()  {
    }
  ClassifyDataRequest_(const ContainerAllocator& _alloc)
    : identifier(_alloc)
    , data(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _identifier_type;
  _identifier_type identifier;

   typedef std::vector< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >::other >  _data_type;
  _data_type data;




  typedef boost::shared_ptr< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ClassifyDataRequest_

typedef ::ml_classifiers::ClassifyDataRequest_<std::allocator<void> > ClassifyDataRequest;

typedef boost::shared_ptr< ::ml_classifiers::ClassifyDataRequest > ClassifyDataRequestPtr;
typedef boost::shared_ptr< ::ml_classifiers::ClassifyDataRequest const> ClassifyDataRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ml_classifiers

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'ml_classifiers': ['/tmp/buildd/ros-hydro-ml-classifiers-0.3.0-1quantal-20150330-2020/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "572733f6e77cd60bddc5c0b72307999c";
  }

  static const char* value(const ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x572733f6e77cd60bULL;
  static const uint64_t static_value2 = 0xddc5c0b72307999cULL;
};

template<class ContainerAllocator>
struct DataType< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ml_classifiers/ClassifyDataRequest";
  }

  static const char* value(const ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string identifier\n\
ClassDataPoint[] data\n\
\n\
================================================================================\n\
MSG: ml_classifiers/ClassDataPoint\n\
string target_class\n\
float64[] point\n\
";
  }

  static const char* value(const ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.identifier);
      stream.next(m.data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ClassifyDataRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ml_classifiers::ClassifyDataRequest_<ContainerAllocator>& v)
  {
    s << indent << "identifier: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.identifier);
    s << indent << "data[]" << std::endl;
    for (size_t i = 0; i < v.data.size(); ++i)
    {
      s << indent << "  data[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::ml_classifiers::ClassDataPoint_<ContainerAllocator> >::stream(s, indent + "    ", v.data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ML_CLASSIFIERS_MESSAGE_CLASSIFYDATAREQUEST_H
