/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-ml-classifiers-0.3.0-1quantal-20150330-2020/srv/CreateClassifier.srv
 *
 */


#ifndef ML_CLASSIFIERS_MESSAGE_CREATECLASSIFIERREQUEST_H
#define ML_CLASSIFIERS_MESSAGE_CREATECLASSIFIERREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace ml_classifiers
{
template <class ContainerAllocator>
struct CreateClassifierRequest_
{
  typedef CreateClassifierRequest_<ContainerAllocator> Type;

  CreateClassifierRequest_()
    : identifier()
    , class_type()  {
    }
  CreateClassifierRequest_(const ContainerAllocator& _alloc)
    : identifier(_alloc)
    , class_type(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _identifier_type;
  _identifier_type identifier;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _class_type_type;
  _class_type_type class_type;




  typedef boost::shared_ptr< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct CreateClassifierRequest_

typedef ::ml_classifiers::CreateClassifierRequest_<std::allocator<void> > CreateClassifierRequest;

typedef boost::shared_ptr< ::ml_classifiers::CreateClassifierRequest > CreateClassifierRequestPtr;
typedef boost::shared_ptr< ::ml_classifiers::CreateClassifierRequest const> CreateClassifierRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ml_classifiers

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'ml_classifiers': ['/tmp/buildd/ros-hydro-ml-classifiers-0.3.0-1quantal-20150330-2020/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "36ef13003ee3b780829219bc11e3359a";
  }

  static const char* value(const ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x36ef13003ee3b780ULL;
  static const uint64_t static_value2 = 0x829219bc11e3359aULL;
};

template<class ContainerAllocator>
struct DataType< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ml_classifiers/CreateClassifierRequest";
  }

  static const char* value(const ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string identifier\n\
string class_type\n\
";
  }

  static const char* value(const ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.identifier);
      stream.next(m.class_type);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct CreateClassifierRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ml_classifiers::CreateClassifierRequest_<ContainerAllocator>& v)
  {
    s << indent << "identifier: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.identifier);
    s << indent << "class_type: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.class_type);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ML_CLASSIFIERS_MESSAGE_CREATECLASSIFIERREQUEST_H
